diff --git a/lisp/emacs-lisp/bytecomp.el b/lisp/emacs-lisp/bytecomp.el
index 7feaf118b86..6bb95e7865b 100644
--- a/lisp/emacs-lisp/bytecomp.el
+++ b/lisp/emacs-lisp/bytecomp.el
@@ -4621,7 +4621,10 @@ byte-compile--cond-switch-prefix
                        (setq switch-var var)
                        (setq switch-test
                              (byte-compile--common-test switch-test fn))
-                       (unless (member value keys)
+                       (if (member value keys)
+                           (byte-compile-warn-x
+                            (car clauses)
+                            "Duplicated value in `cond': %S" value)
                          (push value keys)
                          (push (cons (list value) (or body '(t))) cases))
                        t))))
@@ -4632,7 +4635,10 @@ byte-compile--cond-switch-prefix
                      (setq switch-var var)
                      (setq switch-test
                            (byte-compile--common-test switch-test 'eq))
-                     (unless (memq nil keys)
+                     (if (memq nil keys)
+                         (byte-compile-warn-x
+                          (car clauses)
+                          "Duplicated value in `cond': nil")
                        (push nil keys)
                        (push (cons (list nil) (or body '(t))) cases))
                      t)))
@@ -4655,7 +4661,10 @@ byte-compile--cond-switch-prefix
                                                    (member . equal))))))
                             (let ((vals nil))
                               (dolist (elem value)
-                                (unless (funcall fn elem keys)
+                                (if (funcall fn elem keys)
+                                    (byte-compile-warn-x
+                                     (car clauses)
+                                     "Duplicated value in `cond': %S" elem)
                                   (push elem vals)))
                               (when vals
                                 (setq keys (append vals keys))
